package demo;

import java.util.Iterator;
import org.w3c.dom.Node;
import org.apache.commons.jxpath.JXPathContext;
import org.apache.commons.jxpath.Pointer;

import demo.data.*;
import demo.builder.*;

public class Test extends XPath
{
    public static void main (String args[]) {
	Test test = new Test();
	test.run(args);
    }

    public void run (String[] args) {
	Order anOrder = (new OrderFactory()).createDummyOrder();
	TestHTML testHTML = (TestHTML)getFactory().create("demo.TestHTML");
	anOrder.setNote (testHTML.getDocument());

	System.out.println (testHTML.getDocument().getDocumentElement().getClass().getName());

	JXPathContext context = JXPathContext.newContext(testHTML.getDocument());
	JXPathContext objContext = JXPathContext.newContext(anOrder);

	System.out.println ("---- XPath ----");
	for (int i = 0 ; i < args.length; i++) {
	    System.out.print (args[i] + "--->");
	    for (Iterator iter = context.iteratePointers(args[i]); iter.hasNext() ; ) {
		Pointer pointer = (Pointer)iter.next();
		System.out.println (pointer + "(" + pointer.getNode().getClass().getName() + ") ---> " + pointer.getValue());
		pointer.setValue (pointer);
	    }
	}

	System.out.println ("---- HTML DUMP (Before)----");
	System.out.println (testHTML.toDocument());

	TextMapper.map((Node)(context.getPointer("/HTML/HEAD/TITLE").getNode()), "The Order ID is: " + objContext.getValue("id").toString());

	System.out.println ("---- HTML DUMP (After)----");
	System.out.println (testHTML.toDocument());
    }
}
