package demo;

import java.util.Iterator;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;

import org.w3c.dom.Node;

import org.apache.commons.jxpath.JXPathContext;
import org.apache.commons.jxpath.Pointer;

import org.enhydra.xml.xmlc.StreamXMLCLogger;
import org.enhydra.xml.xmlc.XMLObject;
import org.enhydra.xml.xmlc.StreamXMLCLogger;
import org.enhydra.xml.xmlc.deferredparsing.XMLCDeferredParsingFactory;

public class XPath
{
    static private XMLCDeferredParsingFactory xmlcFactory = null;

    protected XMLCDeferredParsingFactory getFactory() {
	PrintWriter writer = new PrintWriter(new OutputStreamWriter(System.err));
	StreamXMLCLogger logger = new StreamXMLCLogger(writer, writer, writer);
	
	if (xmlcFactory == null) {
	    xmlcFactory = new XMLCDeferredParsingFactory(null, this.getClass().getClassLoader(), null);
	}
	xmlcFactory.addResourceDir(".");
	xmlcFactory.addResourceDir("./input");
	xmlcFactory.addResourceDir("./build/src");
	xmlcFactory.addPackagePrefix("demo");
	xmlcFactory.setDefaultMetaDataPath("input/options.xmlc");
	return xmlcFactory;
    }
    
    public Object query(String file, String query) {
	System.out.println ("query " + file + " with query '" + query + "'");
	
	XMLObject xmlObject = getFactory().createFromFile(file);

	System.out.println("---");
	System.out.println(xmlObject.toDocument());
	System.out.println("---");
	

	JXPathContext context = JXPathContext.newContext(xmlObject);
	
	
	return context.getPointer(query).getNode();
    }

    public static void main (String[] args) {
	XPath xpath = new XPath();
	if (args.length == 2) {
	    System.out.println (xpath.query(args[0], args[1]).getClass().getName());
	} else {
	    System.out.println ("xpath file query");
	}
    }

}

